{- Mateusz Styrczula -}

module Slownie where



type Odmiana = (String, String, String)



rzad :: Int -> Odmiana
rzad r
  | r == 0    = ("","","")
  | r == 1    = ("tysiac","tysiace","tysiecy")
  | r == 2    = ("milion","miliony","milionow")
  | r == 3    = ("miliard","miliardy","miliardow")
  | r == 4    = ("bilion","biliony","bilionow")
  | r == 5    = ("trylion","tryliony","trylionow")
  | r == 6    = ("kwadrylion","kwadryliony","kwadrylionow")
  | r == 7    = ("pentylion","pentyliony","pentylionow")
  | r == 8    = ("sekstylion","sekstyliony","sekstylionow")
  | r == 9    = ("septylion","septyliony","septylionow")
  | r == 10   = ("oktylion","oktyliony","oktylionow")
  | r == 11   = ("nonylion","nonyliony","nonylionow")
  | r == 12   = ("decylion","decyliony","decylionow")
  | r == 13   = ("kwartdecylion","kwartdecyliony","kwartdecylionow")
  | r == 14   = ("kwintdecylion","kwintdecyliony","kwintdecylionow")
  | r == 15   = ("seksdecylion","seksdecyliony","seksdecylionow")
  | r == 16   = ("septdecylion","septdecyliony","septdecylionow")
  | r == 17   = ("oktdecylion","oktdecyliony","oktdecylionow")
  | otherwise = ("googol","google","googli")



jednostka :: Integer -> String
jednostka n
  | n == 0    = "zero"
  | n == 1    = "jeden"
  | n == 2    = "dwa"
  | n == 3    = "trzy"
  | n == 4    = "cztery"
  | n == 5    = "piec"
  | n == 6    = "szesc"
  | n == 7    = "siedem"
  | n == 8    = "osiem"
  | n == 9    = "dziewiec"
  | n == 10   = "dziesiec"
  | n == 11   = "jedenascie"
  | n == 12   = "dwanascie"
  | n == 13   = "trzynascie"
  | n == 14   = "czternascie"
  | n == 15   = "pietnascie"
  | n == 16   = "szesnascie"
  | n == 17   = "siedemnascie"
  | n == 18   = "osiemnascie"
  | n == 19   = "dziewietnascie"
  | otherwise = "INNASCIE"



dziesiatka :: Integer -> String
dziesiatka n
  | n == 1    = "dziesiec"
  | n == 2    = "dwadziescia"
  | n == 3    = "trzydziesci"
  | n == 4    = "czterdziesci"
  | n == 5    = "piecdziesiat"
  | n == 6    = "szescdziesiat"
  | n == 7    = "siedemdziesiat"
  | n == 8    = "osiemdziesiat"
  | n == 9    = "dziewiecdziesiat"
  | otherwise = "INNDZIESIAT"



setka :: Integer -> String
setka n
  | n == 1    = "sto"
  | n == 2    = "dwiescie"
  | n == 3    = "trzysta"
  | n == 4    = "czterysta"
  | n == 5    = "piecset"
  | n == 6    = "szescset"
  | n == 7    = "siedemset"
  | n == 8    = "osiemset"
  | n == 9    = "dziewiecset"
  | otherwise = "INNSET"



slownie :: Integer -> Maybe Odmiana -> String
slownie n odm =
  let
    slow_string :: Integer -> String
    slow_string n = l2s (slow_list n 0 True True) where

      slow_list :: Integer -> Int -> Bool -> Bool -> [String]
      slow_list n r to_jest_jednosc czytaj_zero
        | n == 0    = if r == 0 && czytaj_zero 
                        then (jednostka n) : ri 
                      else if to_jest_jednosc then [] else ri
        | n < 20    = (jednostka n) : ri
        | n < 100   = (dziesiatka (n `div` 10)) : slow_list (n `mod` 10) r False False
        | n < 1000  = (setka (n `div` 100)) : slow_list (n `mod` 100) r False False
        | otherwise = slow_list (n `div` 1000) (r+1) True False ++ slow_list (n `mod` 1000) r True False where

            (ra,rb,rc) = rzad r

            conv :: String -> [String]
            conv "" = []
            conv x = [x]

            ri = if n == 1 && to_jest_jednosc then conv ra
                 else if (n < 10 || n > 19) && n `mod` 10 > 1 && n `mod` 10 < 5 then conv rb
                 else conv rc

      l2s :: [String] -> String
      l2s (l:ls) = foldl (\xs x -> xs ++ " " ++ x) l ls
      l2s [] = ""
  in
    case odm of
      Nothing -> slow_string n
      Just (a,b,c) ->
        if n == 1 then slow_string n ++ " " ++ a
        else if (n `mod` 100 < 10 || n `mod` 100 > 19) && n `mod` 10 > 1 && n `mod` 10 < 5 
               then slow_string n ++ " " ++ b
        else slow_string n ++ " " ++ c
      


zloty_groszy :: Integer -> String
zloty_groszy n = 
  slownie zlotych (Just ("zloty","zlote","zlotych")) ++
  " i " ++
  slownie groszy (Just ("grosz","grosze","groszy")) where
  
  zlotych = n `div` 100
  groszy = n `mod` 100
